 /**
 * <p>Qualitaets- und UnterstuetzungsAgentur - Landesinstitut fuer Schule, Materialien zum schulinternen Lehrplan Informatik SII</p>
 *
 * @version 2014-03-13
 */

/*
 *  15.03.2012
 */
import java.io.*;

public class Morsecodierer {
  private BinaryTree<Zeichen> zeichenBaum;
  // private String morseZeichen = "";

  public Morsecodierer() {
    zeichenBaum = new BinaryTree<Zeichen>(new Zeichen(' '));
    morseLaden();  
  }

  private void morseLaden() {
    String  line;  
    try {
      BufferedReader in = new BufferedReader(new FileReader(new File("morse.csv")));
      while ((line = in.readLine()) != null) {
        verarbeiteZeile(line);
      }
      in.close();
    } catch (Exception e) {
      System.out.println("Dateifehler "+ e.getMessage());
    }    
  }

  private void verarbeiteZeile(String pZeile) {
    char zeichen = ' ';
    String code = "";
    if (pZeile.length() > 2) {
      zeichen = pZeile.charAt(0);
      code = pZeile.substring(2);
    }
    fuegeEin(zeichen, code);
  }

  private void fuegeEin(char pZeichen, String pCode) {
    zeichenBaum = fuegeEin(pZeichen, pCode, zeichenBaum);
  }

  private BinaryTree<Zeichen> fuegeEin(char pZeichen, String pCode, BinaryTree<Zeichen> pTree){
    Zeichen z = new Zeichen(pZeichen);
    if (pTree.isEmpty()) {
      pTree = new BinaryTree<Zeichen>(z);   
    }
    if (pCode.equals("")) {
      pTree.setContent(z);
    } else {
      if (pCode.charAt(0)== '.') {
        pTree.setLeftTree(fuegeEin(pZeichen, pCode.substring(1), pTree.getLeftTree()));
      } else { 
        if (pCode.charAt(0) == '-') {
          pTree.setRightTree(fuegeEin(pZeichen, pCode.substring(1), pTree.getRightTree()));
        }
        else {
          System.out.println("Fehler!");
        }
      }
    }
    return pTree;
  }

  public String encodiereText(String pText) {
    pText=pText.toUpperCase();
    String code = "";
    char zeichen;
    for (int zaehler = 0; zaehler <= pText.length()-1; zaehler++) {
      zeichen = pText.charAt(zaehler);  
      code = code + encodiereZeichen(zeichen,zeichenBaum,"");
      code = code + '/';       
    }        
    return code;
  }

  private String encodiereZeichen(char pZeichen, BinaryTree<Zeichen> pBaum, String pTeilcode) {
    if (pBaum.isEmpty()) {
      return "";
    }
    String ergebnis = "";
    if ((pBaum.getContent()).gibZeichen() == pZeichen) {
      ergebnis =  pTeilcode;
    }
    else {     
      ergebnis = encodiereZeichen(pZeichen, pBaum.getLeftTree(), pTeilcode + ".") + 
                 encodiereZeichen(pZeichen, pBaum.getRightTree(), pTeilcode + "-");
    }  
    return ergebnis;               
  }
  
  public String decodiereText(String pText) {   
    String rest = pText;
    String morse;
    String text = "";
    int index;
    do {
      index = rest.indexOf('/');
      morse = rest.substring(0,index);
      rest = rest.substring(index+1,rest.length());
      if (morse.length() > 0)
        text = text + decodiereZeichen(morse);
    } while (rest.length()>0);        
    return text;
  }


  private char decodiereZeichen(String pMorsecode) {
    BinaryTree<Zeichen> bin = zeichenBaum;
    String code = pMorsecode;
    while (code.length() > 0) {
      if (code.charAt(0) == '.')
        bin = bin.getLeftTree();
      else 
      if (code.charAt(0) == '-')  
        bin = bin.getRightTree();
      else
        System.out.println("Fehler2");
      code = code.substring(1);
    }
    Zeichen z = bin.getContent();
    return z.gibZeichen();
  }

  public BinaryTree<Zeichen> gibBaum() { //fuer  Baumzeichner
    return zeichenBaum;
  }

}
