 /**
 * <p>Qualitaets- und UnterstuetzungsAgentur - Landesinstitut fuer Schule, Materialien zum schulinternen Lehrplan Informatik SII</p>
 *
 * @version 2014-03-13
 */
/**
 * 13.03.2012
 */
public class InformatikerBaum {
  private BinaryTree<Informatiker> baum;

  public InformatikerBaum() {
    baum = new BinaryTree<Informatiker>();
  }

  public void ergaenze(String pName, String pDatum) {
    fuegeEin(baum, pName, pDatum);
  }

  private void fuegeEin(BinaryTree<Informatiker> b, String pName, String pDatum) {   
    if (b.isEmpty()) {
      Informatiker neu = new Informatiker(pName, pDatum);
      b.setContent(neu);
    } else {
      Informatiker inf = b.getContent();
      if (pName.compareTo(inf.gibName()) < 0) {
        fuegeEin(b.getLeftTree(),pName,pDatum);
      } else {
        if (pName.compareTo(inf.gibName()) > 0) {
          fuegeEin(b.getRightTree(),pName,pDatum);
        } else {
          System.out.println("Name bereits vorhanden");
        }
      }
    } 
  }

  public String suche(String pName) {
    return baumSuche(baum,pName);
  }

  private String baumSuche(BinaryTree<Informatiker> b, String pName) {   
    if (b.isEmpty()) {
      return "--";
    } else {
      Informatiker inf = b.getContent();
      if (pName.compareTo(inf.gibName()) < 0) {
        return baumSuche(b.getLeftTree(),pName);
      } else {
        if (pName.compareTo(inf.gibName()) > 0) {
          return baumSuche(b.getRightTree(),pName);
        } else {
          return inf.toString();
        }
      }
    } 
  }

  public String zeigeAlle() {
    return durchlaufe(baum);
  }

  private String durchlaufe(BinaryTree<Informatiker> b) {     
    String aktuell = "";
    String links = "";
    String rechts = "";
    if (!b.isEmpty()) {
      links = durchlaufe(b.getLeftTree());
      aktuell = (b.getContent()).toString() + "\n" ;
      rechts = durchlaufe(b.getRightTree());
    }
    return links + aktuell + rechts ;
  }

  public BinaryTree<Informatiker> gibBaum() {
    return baum;  
  }

}
